# Written by Henrik Nilsen Omma
# (C) Canonical, Ltd. Licensed under the GPL

import os
import time
from bzrlib.bzrdir import BzrDir

default_branch = "http://bazaar.launchpad.net/~bugsquad/bughelper-data/main/"

class BzrError(Exception):
    def __init__(self, error):
        self.value = error
        
    def __str__(self):
        return self.value

def update_packages_data(path, intervall):
    """
    returns stdout and stderr of 'bzr branch' or 'bzr pull'
    """
    result = (None,None)
    if not os.path.exists(path):
        f = os.popen3("bzr branch %s %s" % (default_branch, path))
        sout=f[1].readlines()
        eout=f[2].readlines()
        if not sout and eout[0].startswith("bzr: ERROR:"):
            raise BzrError, eout[0]
        result = (sout,eout)
    else:
        bi = branch_info(path)
        if bi.timestamp + time.timezone + float(intervall)*60*60 <= time.time():
            old_cwd = os.getcwd()
            os.chdir(path)
            f = os.popen3("bzr pull %s" % default_branch)
            os.chdir(old_cwd)
            result = (f[1].readlines(),f[2].readlines())
    return result

class branch_info(object):
    def __init__(self, path):
        tree = BzrDir.open(path).open_workingtree()
        self.revno = tree.branch.revno()
        last_rev = tree.branch.repository.get_revision(tree.last_revision())
        self.timestamp = last_rev.timestamp

